Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTReferenceOperator

All Superinterfaces:
  `IASTAttributeOwner`, `IASTNode`, `IASTPointerOperator`

public interface ICPPASTReferenceOperator extends IASTPointerOperator
This is C++'s reference operator, i.e. &, used in a declarator.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTAttributeOwner

`ATTRIBUTE, ATTRIBUTE_SPECIFIER`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTPointerOperator

`EMPTY_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTReferenceOperator`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTReferenceOperator`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`boolean`
`isRValueReference()`
Returns whether the operator denotes a rvalue reference (e.g.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTAttributeOwner

`addAttribute, addAttributeSpecifier, getAttributes, getAttributeSpecifiers`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Method Details

### isRValueReference

boolean isRValueReference()
Returns whether the operator denotes a rvalue reference (e.g. `int &&`).

Since:
  5.2

### copy

ICPPASTReferenceOperator copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `IASTPointerOperator`
Since:
  5.1

### copy

ICPPASTReferenceOperator copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `IASTPointerOperator`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3